/*
  MeCab -- Yet Another Part-of-Speech and Morphological Analyzer

  $Id: learner.h,v 1.2 2005/12/24 08:24:22 taku-ku Exp $;

  Copyright (C) 2001-2005 Taku Kudo <taku@chasen.org>
  Copyright (C) 2004-2005 Nippon Telegraph and Telephone Corporation

  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef MECAB_LEANER_H
#define MECAB_LEANER_H

#include <vector>

#include "learner_tagger.h"
#include "freelist.h"
#include "feature_index.h"
#include "string_buffer.h"

namespace MeCab {

  class Learner {

  private:
    EncoderFeatureIndex         feature_index_;
    LearnerTokenizer            tokenizer_;
    FreeList<LearnerPath>       path_freelist_;
    std::vector <double>        expected_;
    std::vector <double>        observed_;
    std::vector <double>        alpha_;
    std::vector <EncoderLearnerTagger *> x_;
    StringBuffer what_;
  public:
    void close();
    bool run (Param &, const char*, const char*);
    const char *what () { return what_.str(); }
    Learner (): path_freelist_ (8192 * 256) {};
    virtual ~Learner() { close (); }
  };
}
#endif
