/*
  MeCab -- Yet Another Part-of-Speech and Morphological Analyzer

  $Id: tool.h,v 1.3 2006/01/13 15:24:16 taku-ku Exp $;

  Copyright (C) 2001-2005 Taku Kudo <taku@chasen.org>
  Copyright (C) 2004-2005 Nippon Telegraph and Telephone Corporation

  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _MECAB_TOOL_H
#define _MECAB_TOOL_H

#include "param.h"
#include "string_buffer.h"

namespace MeCab
{
  class Tool {

  private:
    Param param_;
    StringBuffer what_;

    bool dicinfo    ();
    bool learn      ();
    bool test       ();
    bool mktextdic  ();
    bool mkbindic   ();
    bool convmodel  ();
    bool convmatrix ();
    bool loadDicRc  ();

  public:

    const char *what() { return what_.str(); }
    bool run (int argc, char **argv);
  };
}

#endif
